
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class WorkspacesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const workspaces = await db.workspaces.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        plan: data.plan
        ||
        null
            ,
            
        demo_mode_enabled: data.demo_mode_enabled
        ||
        false
        
            ,
            
        trial_ends_at: data.trial_ends_at
        ||
        null
            ,
            
        billing_email: data.billing_email
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await workspaces.setOwner( data.owner || null, {
            transaction,
        });
        
        await workspaces.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return workspaces;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const workspacesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                plan: item.plan
            ||
            null
            ,
            
                demo_mode_enabled: item.demo_mode_enabled
            ||
            false
        
            ,
            
                trial_ends_at: item.trial_ends_at
            ||
            null
            ,
            
                billing_email: item.billing_email
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const workspaces = await db.workspaces.bulkCreate(workspacesData, { transaction });

        // For each item created, replace relation files
        

        return workspaces;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const workspaces = await db.workspaces.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.plan !== undefined) updatePayload.plan = data.plan;
        
        
        if (data.demo_mode_enabled !== undefined) updatePayload.demo_mode_enabled = data.demo_mode_enabled;
        
        
        if (data.trial_ends_at !== undefined) updatePayload.trial_ends_at = data.trial_ends_at;
        
        
        if (data.billing_email !== undefined) updatePayload.billing_email = data.billing_email;
        
        
        updatePayload.updatedById = currentUser.id;

        await workspaces.update(updatePayload, {transaction});

        
        
        if (data.owner !== undefined) {
            await workspaces.setOwner(
              
              data.owner,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await workspaces.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return workspaces;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const workspaces = await db.workspaces.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of workspaces) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of workspaces) {
                await record.destroy({transaction});
            }
        });


        return workspaces;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const workspaces = await db.workspaces.findByPk(id, options);

        await workspaces.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await workspaces.destroy({
            transaction
        });

        return workspaces;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const workspaces = await db.workspaces.findOne(
            { where },
            { transaction },
        );

        if (!workspaces) {
            return workspaces;
        }

        const output = workspaces.get({plain: true});

        
        
        
        
        
        
        
        output.assistant_profiles_workspace = await workspaces.getAssistant_profiles_workspace({
            transaction
        });
        
        
        
        
        
        
        
        
        output.integrations_workspace = await workspaces.getIntegrations_workspace({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.audit_logs_workspace = await workspaces.getAudit_logs_workspace({
            transaction
        });
        
        
        
        output.owner = await workspaces.getOwner({
            transaction
        });
        
        
        output.organizations = await workspaces.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'owner',
        
        where: filter.owner ? {
          [Op.or]: [
            { id: { [Op.in]: filter.owner.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.owner.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'workspaces',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.billing_email) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'workspaces',
                        'billing_email',
                        filter.billing_email,
                    ),
                };
            }
            

            
            

            
            if (filter.trial_ends_atRange) {
                const [start, end] = filter.trial_ends_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    trial_ends_at: {
                    ...where.trial_ends_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    trial_ends_at: {
                    ...where.trial_ends_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.plan) {
                where = {
                    ...where,
                plan: filter.plan,
            };
            }
            
            if (filter.demo_mode_enabled) {
                where = {
                    ...where,
                demo_mode_enabled: filter.demo_mode_enabled,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.workspaces.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'workspaces',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.workspaces.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

